/**
 * Write a description of class BoneLimbController here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class BoneLimbController  
{
    Bone base,arm,hand;
    double baseOffX,baseOffY,armOffX,armOffY,handOffX,handOffY;
    double armLength, handLength;
    
    double angleConst = 0;
    double defaultAng;
    
    double plantX,plantY;
    double destX,destY;
    boolean planted = true;
    boolean replanting = true;
    boolean justPlanted = false;
    double minRatio = .1;
    double maxRatio = .95;
    double resetRatio = .7;
    double maxAngle = 3*Math.PI/4;
    double velConst = 10;
    boolean reset = false;
    
    int inversion = -1;

    
    public BoneLimbController(Bone b,Bone a,Bone h){
        base = b;
        arm = a;
        hand = h;
        defaultAng = angleFunc(Math.atan2(arm.myY - base.myY,arm.myX - base.myX));
    }
    
    public void setLengths(double a,double b){
        armLength = a;
        handLength = b;    
    }
    
    
    public void solve(){
        justPlanted = false;
        double reachLength = Math.sqrt(Math.pow(arm.myX-plantX,2)+Math.pow(arm.myY-plantY,2));
        double ang = Math.acos((sqr(armLength) + sqr(reachLength) - sqr(handLength))/(2*armLength*reachLength));
        double ang3 = Math.atan2(plantY-arm.myY,plantX-arm.myX);
        double ang4 = Math.atan2(plantY - hand.myY,plantX - hand.myX);
        defaultAng = angleFunc(Math.atan2(arm.myY - base.myY,arm.myX - base.myX));
        
        double ratio  = reachLength / (armLength + handLength);
        if(ratio>maxRatio && replanting){ 
            destX = arm.myX + base.velx*velConst + armLength*resetRatio*Math.cos(defaultAng);
            destY = arm.myY + base.vely*velConst + armLength*resetRatio*Math.sin(defaultAng);
            planted = false;
            reset = false;       
        }
        if((diffAng(defaultAng,ang3) > maxAngle  ||  ratio<minRatio) && replanting && planted){
            destX = arm.myX + base.velx*velConst + (armLength+handLength)*maxRatio*Math.cos(defaultAng);
            destY = arm.myY + base.vely*velConst + (armLength+handLength)*maxRatio*Math.sin(defaultAng);
            planted = false;
            reset = false;
        }
        if(reset){
            destX = arm.myX + (armLength+handLength)*resetRatio*Math.cos(defaultAng);
            destY = arm.myY + (armLength+handLength)*resetRatio*Math.sin(defaultAng);
            planted = false;
            reset = false;
        }
        if(!planted){
            double mag = Math.sqrt(Math.pow(destX-plantX,2) + Math.pow(destY-plantY,2));
            //plantX += (destX-plantX)/(7/(Math.abs(base.velx)*2+1)+4);
            //plantY += (destY-plantY)/(7/(Math.abs(base.vely)*2+1)+4);
            plantX += (destX-plantX)/mag + (destX-plantX)/7;
            plantY += (destY-plantY)/mag + (destY-plantY)/7;
            if(Math.abs(plantX-destX)<1 && Math.abs(plantY-destY)<1){
                plantX = destX;
                plantY = destY;
                planted = true;
                justPlanted = true;
            }
        }
        if(isValid(ang4)){
            hand.setRotation(ang4);
        }
        if(isValid(ang3) && isValid(ang)){
            arm.setRotation(ang3-ang*inversion);
        }
         
    }


    public double sqr(double a){
        return a*a;
    }
    
    public void setPlant(double x,double y){
        plantX = x;
        plantY = y;
    }
    
    public boolean isValid(double a){
        return a<100000 && a>-100000;
    }
    
    public void enableReplanting(){
        replanting = true;
    }
    
    public void disableReplanting(){
        replanting = false;
    }
    
    
    public void setReplantable(boolean b){
        replanting = b;
    }
    
    public boolean canReplant(){
        return replanting;
    }
    
    public double diffAng(double a,double b){
        if(Math.abs(a+Math.PI*2 - b) < Math.abs(a - b)){
            a += Math.PI*2;
        }
        if(Math.abs(a-Math.PI*2 - b) < Math.abs(a - b)){
            a -= Math.PI*2;
        }
        return Math.abs(a-b);
    }
    
    public void invert(){
        inversion *= -1;
    }
    
    public void resetLimb(){
        reset = true;
    }
    
    public double angleFunc(double a){
        double s=0;
        if(a>0){
            s = Math.PI + base.angle;
        }
        if(a<0){
            s = -Math.PI + base.angle;
        }
        while(Math.abs(a - s) >  Math.PI){
            if(s>a){
                s -= Math.PI*2;
            }else{
                s += Math.PI*2;
            }
        }
        return a*angleConst + (1-angleConst)*(s);
    }
    
    public void setAngleConstant(double c){
        angleConst = c;
    }
        
    
}