import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Crawler here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Claw  extends Character
{

    bodyPartBelow arm1;
    bodyPartBelow arm2;
    static GreenfootImage open = new GreenfootImage("Monsters/Claw/Claw_open.bmp");
    static GreenfootImage closed = new GreenfootImage("Monsters/Claw/Claw_closed.bmp");
    double cycle = 0;
    double turnAng = 1.5;
    double vel = 2;
    //Tester test = new Tester(); 
    
    MouseInfo mouse;
    int mx,my;
    final double attackRange = 200;
    final double minHidingRange = 100;
    final double maxHidingRange = 90;
    
    boolean playSound = false;
   
    double seekX1,seekY1;
    double seekX2,seekY2;
    double deltaX,deltaY;
    int state = 1;
        // 0    waiting
        // 1    seeking hiding
        // 2    exploring
        // 3    attacking
        // 4    fleeing
    int timer = 0;
    double health = 20;
    final double MAX_HEALTH = 20;
    boolean sleeping = false;
    
    public Claw(boolean s){
        super(0,0);      
        arm1 = new bodyPartBelow(this,0,0,"Monsters/Claw/Claw_arm.bmp");
        arm2 = new bodyPartBelow(arm1,0,0,"Monsters/Claw/Claw_end.bmp");
        setImage(closed);
        clearImage();
        setImage(open);
        clearImage();
        sleeping = s;
    }
    
    protected void addedToWorld(World w){
        super.addedToWorld(w);
        world.addObject(arm1,myX,myY-4);
        world.addObject(arm2,myX,myY-19);
        arm1.setRotation(Math.random()*Math.PI*2);
        arm2.setRotation(Math.random()*Math.PI*2);
        setRotation(Math.random()*Math.PI*2);
        isSolid = false;
        //world.addObject(test,0,0);
    }
    
    public void act() 
    {
        if(sleeping){
            super.act();
            return;
        }
        boolean canSeePlayer = world.canSeePlayer(this);
        
        
        if(destX.size() == 0  && state!=3){
            deltaX *= .8;
            deltaY *= .8;
            if(state == 0){
                health = MAX_HEALTH;
            }
            if(state == 1){
                state = 0;
                timer = 0;
            }
            if(state == 2){
                state = 1;
                search();
            }
            if(canSeePlayer){
                if(world.distanceToPlayer(this) < attackRange){
                    state = 3;
                    timer = 0;
                }else{
                    state = 1;
                    search();
                }
            }
        }
        
        if(state==3 && destX.size()!=0){
            state = 1;
            if(destX.size()==0){
                search();
            }
            
        }
        
        if(state == 3  && destX.size()==0){
            timer++;
            seek(world.tilex+200,world.tiley+200,2);
            double distToPlayer = world.distanceToPlayer(this);
            if(distToPlayer<15){
                world.character.force(.2*Math.cos(angle),.2*Math.sin(angle));
            }
            if(distToPlayer<10){
                world.character.hurt(0,0,4);
            }
            if(timer>400){
                state = 4;
                search();
            }
        }
        
        //System.out.println(world.canSeePlayer(this));
        
        
        vel = Math.sqrt(deltaX*deltaX+deltaY*deltaY);
        
        
        
        if(cycle<100){
            setImage(closed);
            arm1.setLocalRotation(-turnAng*smooth(cycle/100.0));
            arm2.setLocalRotation(turnAng*2*smooth(cycle/100.0));
            cycle += vel*2;
            playSound = true;
        }else{
            if(playSound && distTo(world.character)<200 && Math.random()>.5){
                Greenfoot.playSound("Monsters/Claw/Crawl"+(Greenfoot.getRandomNumber(4)+1)+".mp3");
                playSound = false;
            }
            setImage(open);  
            arm1.setLocalRotation(-turnAng*smooth((200-cycle)/100.0));
            arm2.setLocalRotation(turnAng*2*smooth((200-cycle)/100.0));
            velx = 2.2*smooth((200-cycle)/50.0)*deltaX;
            vely = 2.2*smooth((200-cycle)/50.0)*deltaY;  
        }
        
        cycle += vel*2.7;
        //super.angle = Math.atan2(my-myY,mx-myX)-Math.PI/2;
        //rotate(.01);
        if(cycle>200){
            cycle = 0;
            turnAng = turnAng;
        }
        
        if(state == 0){
            deltaX = 0;
            deltaY = 0;
            timer++;
            if(timer<50){
                rotate(Math.PI/50.0);
            }
        }else{
            setRotation(Math.atan2(vely,velx)-Math.PI/2);
        }
        //move(velx,vely);
        move(0,0);
        super.act();
    }    
    
    public double smooth(double in){
        if(in>1){
            in = 2 - in;
        }
        return in*in*3 - 2*in*in*in;
    }
    
    public int radius(){
        return 0;
    }
    
    public void seek(double x,double y,double s){
        double mag = dist(x-myX,y-myY);
        deltaX += (((x-myX)*s/mag) - deltaX)/5.0;
        deltaY += (((y-myY)*s/mag) - deltaY)/5.0;
        if(mag<s){
            setBoneLocation(x,y);
        }
    }
    
    public void search(){
        if(destX.size()!=0){
            return;
        }
        ArrayList<Location2D> hidingTiles = new ArrayList<Location2D>();
        ArrayList<Location2D> exploreTiles = new ArrayList<Location2D>();
        int[] arrX = {40,0,-40,0};
        int[] arrY = {0,40,0,-40};
        int offset = (int)((Math.atan2(myY - world.character.myY,myX - world.character.myX)+5*Math.PI/4)*4/(Math.PI*2));
        int vx = -arrX[offset%4];
        int vy = -arrY[offset%4];
            
        double tx = ((int)(myX/40))*40 + 20;
        double ty = ((int)(myY/40))*40 + 20;
        while(!world.solid(tx,ty)){
            double sx = tx;
            double sy = ty;
            boolean foundWall = false;
            boolean foundOtherWall = false;
            boolean explored = false;
            while(!world.solid(sx + vy,sy - vx)){
                sx += vy;
                sy -= vx;
                if(!foundWall && world.solid(sx-vx,sy-vy) && !world.solid(sx + vy,sy - vx)){
                    hidingTiles.add(new Location2D(sx,sy));
                    foundWall = true;
                }
                if(!foundOtherWall && world.solid(sx+vx,sy+vy)){
                    foundOtherWall = true;
                }
                if(!explored && ((foundOtherWall && !world.solid(sx+vx,sy+vy)) || (foundWall && !world.solid(sx-vx,sy-vy)))){
                    exploreTiles.add(new Location2D(sx,sy));
                    explored = true;
                }   
            }
            if(world.solid(sx-vx,sy-vy)){
                hidingTiles.add(new Location2D(sx,sy));
            }
            sx = tx;
            sy = ty;
            foundWall = false;
            foundOtherWall = false;
            explored = false;
            while(!world.solid(sx - vy,sy + vx)){
                sx -= vy;
                sy += vx;
                if(!foundWall && world.solid(sx-vx,sy-vy) && !world.solid(sx - vy,sy + vx)){
                    hidingTiles.add(new Location2D(sx,sy));
                    foundWall = true;
                }
                if(!foundOtherWall && world.solid(sx+vx,sy+vy)){
                    foundOtherWall = true;
                }
                if(!explored && ((foundOtherWall && !world.solid(sx+vx,sy+vy)) || (foundWall && !world.solid(sx-vx,sy-vy)))){
                    exploreTiles.add(new Location2D(sx,sy));
                    explored = true;
                }   
            }
            if(world.solid(sx-vx,sy-vy)){
                hidingTiles.add(new Location2D(sx,sy));
            }
            
            tx += vx;
            ty += vy;
        }
        //System.out.println(hidingTiles.size() + " hiding tiles found");
        //System.out.println(exploreTiles.size() + " exploration tiles found");
        for(int i=0;i<hidingTiles.size();i++){
            Location2D loc = hidingTiles.get(i);
            if(loc.distanceTo(myX,myY)<minHidingRange  ||  world.canSeePlayer(loc.x,loc.y)){
                hidingTiles.remove(i);
            }
        }  
        for(int i=0;i<exploreTiles.size();i++){
            Location2D loc = exploreTiles.get(i);
            if(world.canSeePlayer(loc.x,loc.y)){
                exploreTiles.remove(i);
            }
        } 
        if(hidingTiles.size()==0 && exploreTiles.size()==0){
            if(world.canSeePlayer(this)){
                state = 3;
                timer = 0;
            }else{
                state = 0;
                timer = 0;
            }
            return;
        }
        if(hidingTiles.size()==0  ||  (Math.random()>.3 && exploreTiles.size()!=0)){
            Location2D seeking = exploreTiles.get(Greenfoot.getRandomNumber(exploreTiles.size()));
            if(vx == 0){
                seekX1 = tx;
                seekY1 = seeking.y;
            }else{
                seekX1 = seeking.x;
                seekY1 = ty;
            }
            seekX2 = seeking.x;
            seekY2 = seeking.y;  
            state = 2;
        }else{
            Location2D seeking = hidingTiles.get(Greenfoot.getRandomNumber(hidingTiles.size()));
            if(vx == 0){
                seekX1 = tx;
                seekY1 = seeking.y;
            }else{
                seekX1 = seeking.x;
                seekY1 = ty;
            }
            seekX2 = seeking.x;
            seekY2 = seeking.y;
            state = 1;
        }
        addDestination(seekX1,seekY1,2);
        addDestination(seekX2,seekY2,2);
    }
    
    public void hurt(double dx,double dy,double mag){
        if(sleeping){
            return;
        }
        health -= mag;   
        System.out.println(mag);
        Greenfoot.playSound("Materials/flesh_hit_"+(Greenfoot.getRandomNumber(2)+1) + ".mp3");
        if(health <= 0){
            List<Bone> all = getConnectedBones();   
            for(int i=0;i<all.size();i++){
                world.addObject(new shrapnel(all.get(i),0,0,2,false),myX,myY);
            }  
            world.addObject(new BloodSplatter(80,40),myX,myY);
            removeAllBones();
            //Greenfoot.playSound("Monsters/Zombie/Zombie_die"+(Greenfoot.getRandomNumber(2)+1)+".mp3");
        }
    }
    
    public boolean action(int a){
        actionNumber = a;
        switch(a){
            case 2:sleeping = false;state = 3;return true;
        }
        return false;
    }
    
}