import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;


public class Crate  extends SolidActor
{
    int tilex,tiley;
    double health = 3;
    
    double[] shadowX = {0,0,0,0,0};
    double[] shadowY = {0,0,0,0,0};
    
    public Crate(int s){
        getImage().scale(s,s);
        shadowX[0] = s/2;
        shadowX[1] = s/2;
        shadowX[2] = -s/2;
        shadowX[3] = -s/2;
        shadowX[4] = s/2;
        shadowY[0] = s/2;
        shadowY[1] = -s/2;
        shadowY[2] = -s/2;
        shadowY[3] = s/2;
        shadowY[4] = s/2;
    }
    
    protected void addedToWorld(World world){
        super.addedToWorld(world);
        tilex = (int)myX/40;
        tiley = (int)myY/40;
        //((world)world).tilesolid[tilex][tiley] = 1;
        shadowLevel = 2;
    }
    
    public void act() 
    {
        super.act();    
    }    
    
    public boolean action(int a){
        actionNumber = a;
        switch(a){
            case 3:breakCrate();return true;
        }
        return false;
    }
    
    public void hurt(double a,double b,double c){
        velx = a;
        vely = b;
        actionNumber = 2;
        
        if(Math.random()>.5){
            Greenfoot.playSound("Materials/crate_hit_1.mp3");
        }else{
            Greenfoot.playSound("Materials/crate_hit_2.mp3");
        }
        health -= 1;
        final int marks = 20;
        int[] tx = new int[marks];
        int[] ty = new int[marks];
        getImage().setColor(new Color(60,30,0,60));
        for(int i=0;i<marks;i++){
            tx[i] = Greenfoot.getRandomNumber(getImage().getWidth()*2) - getImage().getWidth()/2;
            ty[i] = Greenfoot.getRandomNumber(getImage().getHeight()*2) - getImage().getHeight()/2;
        }
        getImage().drawPolygon(tx,ty,marks);
        if(health<0){
            action(3);
        }
    }
    
    public void breakCrate(){
        //((world)world).tilesolid[tilex][tiley] = 0;
        explode(0,0,2,6);    
        Greenfoot.playSound("Materials/crate_break_1.mp3");
    }
    
    public double[] getShadowX(){
        return shadowX;
    }
    
    public double[] getShadowY(){
        return shadowY;
    }
}
