import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

public class Dave  extends Character
{

    double velx,vely;
    double deltaX,deltaY;
    Tester test = new Tester();
    boolean frozen = false;
    
    public Dave(){
        super(0,0);
        clearImage();
    }
    
    public Dave(boolean f){
        super(0,0);
        clearImage();
        frozen = f;
    }
    
    protected void addedToWorld(World world){
        super.addedToWorld(world);
        world.addObject(test,0,0);
    }
    
    public void act() 
    {
        if(frozen){
            move(0,0);
            super.act();
            return;
        }
        //System.out.println(ang);
        boolean canSeePlayer = world.canSeePlayer(this);
        //if(!world.flashlightHasLight() || (Math.abs(ang)<2.4 && distTo(world.character.myX,world.character.myY)>80)){
        if(world.isDark(myX+15,myY+15) && world.isDark(myX-15,myY+15) && world.isDark(myX+15,myY-15) && world.isDark(myX-15,myY-15)){ 
            seek(world.tilex+200,world.tiley+200,.2);
        
            velx += deltaX;
            vely += deltaY;
            
            test.setLocation((int)(getX()+45*Math.cos(super.angle)),(int)(getY()+45*Math.sin(super.angle)));
            Door door = test.getDoor();
            if(door!=null){
                    
                double dif = door.closedAngle - (super.angle/Math.PI*180);
                while(dif<-90){
                    dif += 180;
                }
                while(dif>90){
                    dif -= 180;
                }
                    //System.out.println(dif);
                if(Math.abs(dif) > 45){
                    door.action(6);
                }
            }
        }
          
        move(0,0);
        
        super.act();
        deltaX = 0;
        deltaY = 0;
        
        if(super.angle<-Math.PI){
            super.angle += Math.PI*2;
        }
        if(super.angle>Math.PI){
            super.angle -= Math.PI*2;
        }
    }    
    
    public void hurt(double a,double b,double c){
        super.hurt(a,b,c);
    }
    
    public void seek(double x,double y,double speed){
        towards(Math.atan2(y-myY,x-myX));
        deltaX = Math.cos(super.angle)*speed;
        deltaY = Math.sin(super.angle)*speed;
    }
    
    public void towards(double tang){
       if(Math.abs(super.angle-(Math.PI*2+tang)) < Math.abs(super.angle-tang)){
           tang = tang+Math.PI*2;
       }
       if(Math.abs(super.angle-(-Math.PI*2+tang)) < Math.abs(super.angle-tang)){
           tang = tang-Math.PI*2;
       } 
       super.angle += (tang - super.angle)/8;
    }
}
