import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Door here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Door  extends ActionActor
{
    double[] shadowX = {-2,42};
    double[] shadowY = {0,0};
    boolean open = false;
    boolean locked = false;
    boolean frozen = false;
    int closedAngle;
    int offset = 0;
    int dir;
    int ind = 0;
    
    boolean side;
    
    Door friend = null;
    boolean second = false;
    boolean sounded = false;
    
    int tx1,tx2,ty1,ty2;
    int[] ax1 = {0 ,0 ,-1,-1};
    int[] ay1 = {-1,0 ,0 ,-1};
    int[] ax2 = {0 ,-1,-1, 0};
    int[] ay2 = {0 ,0 ,-1,-1};
    double[] doorXN = new double[4];
    double[] doorYN = new double[4];
    boolean tileCorrection = false;
    int stickyAngle;

    public Door(boolean l,boolean o,int rot){
        locked = l;
        open = o;
        closedAngle = rot;
        if(open){
            offset = 90;
        }
        for(int i=0;i<360;i+=90){
            doorXN[i/90] = 2*Math.cos(i/180.0*Math.PI + Math.PI/2);
            doorYN[i/90] = 2*Math.sin(i/180.0*Math.PI + Math.PI/2);
        }
        clearImage();
        stickyAngle = closedAngle + offset;
        shadowLevel = 1;
    }
    
    public Door(Door m){
        friend = m;
        second = true;
        m.friend = this;
        
        locked = m.locked;
        open = m.open;
        closedAngle = (m.closedAngle+180)%360;
        if(open){
            offset = -90;
        }
        for(int i=0;i<360;i+=90){
            doorXN[i/90] = 2*Math.cos(i/180.0*Math.PI + Math.PI/2);
            doorYN[i/90] = 2*Math.sin(i/180.0*Math.PI + Math.PI/2);
        }
        clearImage();
        stickyAngle = closedAngle + offset;
        shadowLevel = 1;
        shadowX[1] = 40;
        friend.shadowX[1] = 40;
    }
    
    protected void addedToWorld(World w){
        super.addedToWorld(w);
        if(friend!=null && !second){
            world.addObject(friend,myX+80*Math.cos(closedAngle/180.0*Math.PI),myY+80*Math.sin(closedAngle/180.0*Math.PI)); 
        }
        tileCorrection();
    } 
    
    public double[] getShadowX(){
        return shadowX;
    }
    
    public double[] getShadowY(){
        return shadowY;
    }
        
    public void act() 
    {   
        double dot = (getX()-200)*doorXN[stickyAngle%360/90] + (getY()-200)*doorYN[stickyAngle%360/90];
        side = dot>0;
        if(side){
            //shadowY[0] = 1;
            //shadowY[1] = 1;
        }else{
            //shadowY[0] = -1;
            //shadowY[1] = -1;
        }
            
        if(tileCorrection){
            if(side){
                world.tilesolid[(int)(myX/40) + tx1][(int)(myY/40) + ty1] = 0;
                world.tilesolid[(int)(myX/40) + tx2][(int)(myY/40) + ty2] = 1;
            }else{
                world.tilesolid[(int)(myX/40) + tx1][(int)(myY/40) + ty1] = 1;
                world.tilesolid[(int)(myX/40) + tx2][(int)(myY/40) + ty2] = 0;
            }
        }
        if(second){
            offset = -friend.offset;
            open = friend.open;
            locked = friend.locked;
            frozen = friend.frozen;
        }
        setRotationDegrees(closedAngle + offset);
        
        if(getRotation()%90 == 0){
            stickyAngle = getRotation();
        }

        if(!second){
            if(open && (getRotation()%90!=0)){
                offset += dir;
                if(offset%90 == 0){
                    if(!second)
                        Greenfoot.playSound("Doors/door_open.mp3");
                    tileCorrection();
                }
            }
            if(!open && getRotation()!=closedAngle){
                if(offset<0){
                    offset += 3;
                }else{
                    offset -= 3;
                }
                if((getOneIntersectingObject(SolidActor.class)!=null || (!second && friend!=null && friend.getOneIntersectingObject(SolidActor.class)!=null)) && Math.abs(offset)>4){     
                    block();
                }
                if(offset == 0){
                    if(!second)
                        Greenfoot.playSound("Doors/door_close.mp3");  
                    tileCorrection();
                }
            }
        }
        sounded = false;
        super.act();
    }   
    
    public void block(){
        if(offset<0){
            dir = -3;
        }else{
            dir = 3;
        }
        open = true;
    }
    
    public void tileCorrection(){
        if(friend!=null && !second){
            friend.offset = -offset;
            friend.tileCorrection();
        }
        if(tileCorrection){
            world.tilesolid[(int)(myX/40) + tx1][(int)(myY/40) + ty1] = 0;
            world.tilesolid[(int)(myX/40) + tx2][(int)(myY/40) + ty2] = 0;
        }
        tx1 = ax1[(closedAngle + offset + 360)%360/90];
        tx2 = ax2[(closedAngle + offset + 360)%360/90];
        ty1 = ay1[(closedAngle + offset + 360)%360/90];
        ty2 = ay2[(closedAngle + offset + 360)%360/90];
        tileCorrection = true;
        if(world.tilesolid[(int)(myX/40) + tx1][(int)(myY/40) + ty1] != 0  ||
           world.tilesolid[(int)(myX/40) + tx2][(int)(myY/40) + ty2] != 0){
               tileCorrection = false;
        }
    }
    
    public boolean action(int a){
        actionNumber = a;
        if(second){
            return friend.action(a);
        }
        switch(a){
            case 1: use();return true;
            case 2: closeFast();return true;
            case 3: openFast();return true;
            case 4: lock();return true;
            case 5: unlock();return true;
            case 6: open();return true;
            case 7: close();return true;
            case 8: openAway();return true;
            case 9: openAwayFast();return true;
        }
        return false;
    }
        
    
    //Open/Close    does nothing if in middle of action.  Moves normaly
    //              Unlocks door if already locked
    public void use(){
        if(offset%90!=0 && open){
            return;
        }
        if(frozen || (locked && getRotation()==closedAngle) || getRotation()%90!=0){
            if(locked && !second && !sounded){
                Greenfoot.playSound("Doors/door_locked.mp3");
                sounded = true;
            }
            return;
        } 
        locked = false;
        open = !open;
        if(!second)
            Greenfoot.playSound("Doors/door_latch.mp3");
        if(side){
            dir = 3;
        }else{
            dir = -3;
        }
        if(open){
            offset += dir;
        }
    }
    
    //Close    Works immidiately and silently
    //              Sets status to location and Locked
    public void closeFast(){
        open = false;
        offset = 0;
        locked = true;   
        tileCorrection();
    }
    
    //Open      Works immidiately and silently
    //                Sets status to location and unlocked
    public void openFast(){
        if(open){
            return;
        }
        open = true;
        locked = false;
        double dot = (getX()-200)*doorXN[getRotation()%360/90] + (getY()-200)*doorYN[getRotation()%360/90];
        if(dot>0){
            offset = 90;
        }else{
            offset = -90;
        }  
        tileCorrection();
    }
    
    public void openAwayFast(){
        if(open){
            return;
        }
        open = true;
        locked = false;
        double dot = (getX()-200)*doorXN[getRotation()%360/90] + (getY()-200)*doorYN[getRotation()%360/90];
        if(dot>0){
            offset = -90;
        }else{
            offset = 90;
        }  
        tileCorrection();
    }
    
    //Lock/Unlock   Toggles the locked state of the door
    public void lock(){
        locked = true;   
    } 
    
    //Lock/Unlock   Toggles the locked state of the door
    public void unlock(){
        locked = false;   
    }  
    
    public void open(){
        if(open){
            return;
        }
        locked = false;
        open = true;
        if(!second)
            Greenfoot.playSound("Doors/door_latch.mp3");
        if(!side){
            dir = 3;
        }else{
            dir = -3;
        }
        offset += dir;
    }
    
    public void openAway(){
        locked = false;
        open = true;
        if(!second)
            Greenfoot.playSound("Doors/door_latch.mp3");
        if(!side){
            dir = -3;
        }else{
            dir = 3;
        }
        offset += dir;
    }
    
    public void close(){
        open = false;
        if(!second){
            Greenfoot.playSound("Doors/door_latch.mp3");
        }
    }
    
    public void freeze(){
        frozen = true;
    }
    
    public void unfreeze(){
        frozen = false;
    }
    
    public void explode(double strength,double angle,double spread,int pieces){
        world.tilesolid[(int)(myX/40) + tx1][(int)(myY/40) + ty1] = 0;
        world.tilesolid[(int)(myX/40) + tx2][(int)(myY/40) + ty2] = 0;
        super.explode(strength,angle,spread,pieces);
    }
    
        
}
