import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Flare here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Flare extends ActionActor
{
    final static int radius = 120;
    static GreenfootImage lightMask = new GreenfootImage("Gradient.png");
    GreenfootImage flareFire = new GreenfootImage("FlareFire.png");
    GlowingImage fire1 = new GlowingImage(flareFire);
    GlowingImage fire2 = new GlowingImage(flareFire);
    GlowingImage myOverlay = new GlowingImage("FlareOverlay.png");
    
    StaticLight staticLight;
    boolean insideWall = false;
    boolean dead = false;
    
    boolean isLit = false;
    int timer = 0;
    final int maxLife = 2400;
    final int brightLife = 1600;
        
    public Flare(){
        if(lightMask.getWidth()!=radius*2){
            lightMask.scale(radius*2,radius*2);
        }
        timer = 0;
    }
    
    protected void addedToWorld(World w){
        super.addedToWorld(w);
        world.addObject(myOverlay,0.0,0.0);
        setRotation(Math.random()*360);
        myOverlay.getImage().setTransparency(0);
    }
    
    public void act() 
    {
        if(dead){
            super.act();
            return;
        }
        if(world.distanceToPlayer(this) < 10){
            if(myOverlay.getImage().getTransparency()>10){
                myOverlay.getImage().setTransparency(myOverlay.getImage().getTransparency()-10);
            }else{
                myOverlay.getImage().setTransparency(0);
            }
        }else{
            if(myOverlay.getImage().getTransparency()!=255){
                myOverlay.getImage().setTransparency(myOverlay.getImage().getTransparency()+5);
            }
        }
        
        double characterAngle = Math.atan2(world.character.myY - myY,world.character.myX - myX);
        while(isInsideWall()){
            move(Math.cos(characterAngle),Math.sin(characterAngle));
        }
        
        if(staticLight != null){
            staticLight.setBrightness(getBrightness());
        }
        
        
        if(isLit){
            fire1.setLocation(myX + Math.cos(angle)*5,myY + Math.sin(angle)*5);
            fire2.setLocation(fire1.myX,fire1.myY);
            fire1.setRotation(180*Math.cos(timer));
            fire2.setRotation(-120*Math.sin(timer));
            fire1.getImage().setTransparency((int)(getBrightness()*255));
            fire2.getImage().setTransparency((int)(getBrightness()*255));
            timer++;
        }
        
        if(Greenfoot.isKeyDown("b")){
            timer = -12391239;
        }
        
        if(timer>=maxLife){
            world.removeObject(fire1);
            world.removeObject(fire2);
            if(world.character.hasFlare && world.character.currentFlare==this){
                world.character.releaseFlare();
            }
            world.removeObject(myOverlay);
            if(staticLight!=null){
                world.removeObject(staticLight);
                staticLight = null;
            }  
            dead = true;
        }
 
        super.act();
        myOverlay.setLocation(myX,myY);
        myOverlay.setRotation(angle);
    }    
    
    public boolean action(int a){
        if(dead){
            return false;
        }
        actionNumber = a;
        
        switch(a){
            case 1:boolean ret = !dead  && world.character.currentFlare!=this;
                   grabbed();
                   return ret;
        }
        return false;
    }
    
    public void grabbed(){
        if(world.character.hasFlare){
            return;
        }
        world.character.grabFlare(this); 
        isLit = true;
        world.addObject(fire1,0.0,0.0);
        world.addObject(fire2,0.0,0.0);
        world.removeObject(staticLight);
        staticLight = null;
    }
    
    public void release(){
        double characterAngle = Math.atan2(world.character.myY - myY,world.character.myX - myX);
        while(isInsideWall()){
            move(Math.cos(characterAngle),Math.sin(characterAngle));
        }
        staticLight = new StaticLight(radius,(float).5);
        staticLight.setFlicker(.1);
        staticLight.setFlickerSplit(0);
        world.addObject(staticLight,myX,myY);
    }
    
    public void grab(double x,double y,double ang){
        myX = x;
        myY = y;
        setRotation(ang);
    }
    
    public boolean isInsideWall(){
        return world.tileSolid(myX+5,myY+5) || world.tileSolid(myX-5,myY+5) || world.tileSolid(myX+5,myY-5) || world.tileSolid(myX-5,myY-5);
    }
    
    public double getBrightness(){
        if(timer<brightLife){
            return Math.random()*.1 + .9;
        }else{
            return Math.random()*.1 + .9*(maxLife-timer)/(maxLife-brightLife);
        }
    }
}
