import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Spider here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Spider extends Character
{
    static GreenfootImage image = new GreenfootImage("Monsters/Spider/Body.bmp");
    static GreenfootImage leg = new GreenfootImage("Monsters/Spider/Leg.bmp");
    static GreenfootImage foot = new GreenfootImage("Monsters/Spider/Foot.bmp");
    
    GreenfootSound[] stepSounds = {new GreenfootSound("Monsters/Spider/Step1.mp3"),
                                   new GreenfootSound("Monsters/Spider/Step2.mp3"),
                                   new GreenfootSound("Monsters/Spider/Step2.mp3")};
    
    bodyPartAbove head;
    BoneSkeletonController controller;
    int mx,my;
    double maxVel = 1;
    
    public Spider(){
        super(0,0);
        setImage(image);
        
        head = new bodyPartAbove(this,0,0,"Monsters/Spider/Head.bmp");
    }
    
    protected void addedToWorld(World w){
        super.addedToWorld(w);
        controller = new BoneSkeletonController(this,5,Math.PI/8,8,22,1,22,1,leg,foot,(world)w);
        controller.setAngleConstant(.6);
        controller.setCycleMode(0);
        controller.setCycleLength(10);
        world.addObject(head,myX+20,myY);
    }
    
    public void act() 
    {
        
        
        move(velx,vely);
        if(Math.abs(velx)+Math.abs(vely) < .1){
            //controller.resetLimbs();
        }else{
            towards(Math.atan2(vely,velx));
        }
        
        move(0,0);
        controller.solve();
        //controller1.solve();
        //controller2.solve();
        //controller3.solve();
        super.act();
    }    
    
    public void seek(double x,double y,double s){
        velx = (x-myX)/10.0;
        vely = (y-myY)/10.0;
        double vel = Math.sqrt(velx*velx + vely*vely);
        if(vel > s){
            velx = s*velx/vel;
            vely = s*vely/vel;
        }
    }
    
    public void towards(double tang){
        if(Math.abs(angle-(Math.PI*2+tang)) < Math.abs(angle-tang)){
            tang = tang+Math.PI*2;
        }
        if(Math.abs(angle-(-Math.PI*2+tang)) < Math.abs(angle-tang)){
            tang = tang-Math.PI*2;
        } 
        double dif = (tang - angle)/(60/(maxVel+1));
        rotate(dif);
        //head.rotate((dif - head.angle)/4);
        
        if(angle < 0){
            rotate(Math.PI*2);
        }
        if(super.angle > Math.PI*2){
            rotate(-Math.PI*2);
        }
    }
    
    public boolean action(int a){
        actionNumber = a;
        switch(a){
            case 20: stepSound();return true;
        }
        return false;
    }
    
    public void stepSound(){
        int index = Greenfoot.getRandomNumber(3);
        for(int i=0;i<3;i++){
            double dist = world.distanceToPlayer(this);
            double percent = (500-dist)/500;
            if(percent<0){
                percent = 0;
            }
            stepSounds[i].setVolume((int)(percent*100));
            if(!stepSounds[index].isPlaying()){
                stepSounds[index].play();
            }
            index++;
            index ^= 3;
        }
    }
}
