import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Trigger here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Trigger  extends Actor
{
    Actor parent;
    int jumpAddress;
    boolean sleeping = false;
    boolean sustaining = false;
    boolean active = false;
    
    boolean edgeTriggered = false;
    boolean enabled = true;
    
    
    public void setJumpAddress(int j){
        jumpAddress = j;
    }
    
    public void setParent(Actor a){
        parent = a;
    }
    
    public void act(){
        if(!active){
            enabled = true;
        }
        active = false;
        if(parent.getWorld() == null){
            getWorld().removeObject(this);
        }
    }
    
    public void trigger(){
        active = true;
        if(sleeping){
            return;
        }
        enabled = false;
        
        if(parent instanceof EventScript){
            if(((EventScript)parent).trigger(jumpAddress)){
                if(!sustaining){
                    getWorld().removeObject(this);
                }
            }
        }else{
            ((Trigger)parent).trigger();
        }    
    }
    
    public void sleep(){
        sleeping = true;
    }
    
    public void wake(){
        sleeping = false;
    }
    
    public void sustain(){
        sustaining  = true;
    }
    
    public void end(){
        if(getWorld()==null){
            return;
        }
        getWorld().removeObject(this);
    }
    
    public void setEdge(boolean e){
        edgeTriggered = e;
    }
}
