import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.*;
import java.awt.image.BufferedImage;
import java.awt.Graphics2D;
import java.awt.AlphaComposite;
import java.awt.Composite;
import java.awt.Rectangle;
import java.awt.Polygon;
import java.awt.Color;

import greenfoot.core.WorldHandler;  
import java.awt.event.*;
import javax.swing.*;
import java.awt.Cursor;
import java.awt.Image;
import java.awt.Point;
import java.awt.Toolkit;
import javax.swing.ImageIcon;




public class menu extends World
{

    JPanel panel = WorldHandler.getInstance().getWorldCanvas();  
    Cursor customCursor;
    ScrollingListener scroll = new ScrollingListener();
    
    MouseInfo mouse;
    int mx,my;
    double mouseAng;
    boolean pressed;
    
    //PLAYER LOGIN
    GreenfootImage loginImage;
    boolean isLoggedIn = false;
    int loggedInTimer = 0;
    int loggedInPosition = 400;
    int farthestLevel = 0;
    
    //LEVEL SELECT
    final static int levelNumber = 5;
    
    //MAIN MENU
    boolean inMenu = true;
    final int introMax = 1;  //default is 260
    int intro = introMax;
    //GreenfootSound menuIntroSound = new GreenfootSound("Ambiance/MenuIntro.mp3");
    //Sound menuLoop = new Sound("Ambiance/MenuLoop.mp3");
    GreenfootImage back;// = new GreenfootImage("NH.bmp");
    FastImage NH;// = new FastImage(back);
    FastImage image;
    int menuNumber = 0;     //0 main menu
                            //1 options menu
    MouseImage mouseCursor = new MouseImage();
    final static int[] levelOffsets = {1,3,4,7,9,30,30,30,30};
    String[] levelNames = {"Intro","Emergence","Surgery","Recovery","Maintenance"};
    
    Slider shadowSlider;
    Slider curveSlider;
    Slider particleSlider;
    Slider musicSlider;
    Button backButton;
    Button rightButton;
    Button leftButton;
    Button[] panes = new Button[4];
    int paneStart = 0;
    Checkbox qualityBox;
    TextEntry textEntry;
    
    world childWorld;
    
    public menu()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(400, 400, 1); 
         
        if(UserInfo.isStorageAvailable()){
            isLoggedIn = true;
            UserInfo myInfo = UserInfo.getMyInfo();
            loginImage = new GreenfootImage("Menu/LoggedIn.bmp");
            GreenfootImage playerIcon = myInfo.getUserImage();
            for(int i=0;i<50;i++){
                for(int j=0;j<61;j++){
                    if(loginImage.getColorAt(i,j).equals(Color.red)){
                        loginImage.setColorAt(i,j,playerIcon.getColorAt(i,j));
                    }
                }
            }   
            if(myInfo.getInt(5)==0){
                myInfo.setInt(4,60);
                myInfo.setInt(5,1);
                myInfo.setInt(6,1);
                myInfo.store();
            }
            farthestLevel = myInfo.getInt(6);
        }
        
        
        childWorld = new world();
        childWorld.myMenu = this;
        childWorld.loadPlayerGame();
        loadMenu();
        getBackground().setColor(Color.black);
        getBackground().fill();
    }
    
    public void act(){
        if(Greenfoot.isKeyDown("r")){
            UserInfo myInfo = UserInfo.getMyInfo();
            for(int i=0;i<10;i++){
                myInfo.setInt(i,0);
            }
            farthestLevel = 0;
            System.out.println("Saved Data Reset");
            myInfo.store();
        }
        if(Greenfoot.getMouseInfo()!=null){
            mouse = Greenfoot.getMouseInfo();
            mx = mouse.getX();
            my = mouse.getY();
            mouseAng = Math.atan2(my-200,mx-200);
        }
        menu();
        if(isLoggedIn){
            if(loggedInPosition<400){
                getBackground().drawImage(loginImage,350,loggedInPosition);
            }
            loggedInTimer++;
            if(loggedInTimer < 300){
                if(loggedInPosition!=339){
                    loggedInPosition--;
                }
            }else{
                loggedInPosition++;
            }       
        }
    }
    
    public void setChildWorld(world w){
        childWorld = w;
    }
    
    public void loadMenu(){
        
        image = new FastImage(getBackground());
        back = new GreenfootImage("Menu/NH.bmp");
        NH = new FastImage(back);
        //inMenu = true;
        //resetCursor();
        //worldBackup = new WorldBackup(this);
        //addObject(menuLoop,0,0);
    }
    
    public void exitMenu(){
        menuNumber = 0;
        removeObjects(getObjects(Pressable.class));
        image = null;
        back = null;
        NH = null;
        inMenu = false;
        //enableCustomCursor();
        //worldBackup.restore();
        //worldBackup = null;
        Greenfoot.setWorld(childWorld);
        childWorld.exitMenu();
        //menuLoop.fadeOut(200);
    }
    
    public void menu(){
        if(intro == introMax){
            //Greenfoot.playSound("Ambiance/MenuIntro.mp3");
        }
        if(intro!=0){
            intro--;
            if(intro==0){
                //Greenfoot.playSound("Ambiance/MenuLoop.mp3");
            }
            return;
        }
        double rat = Math.pow(Math.random()*.1,2);
        int[] color = new int[4];
        color[3] = 255;
        
        int max1 =0;
        int max2 =0;
        if(Greenfoot.mousePressed(null))
            pressed = true;
        if(Greenfoot.mouseClicked(null) || Greenfoot.isKeyDown("enter")){
            pressed = false;
            boolean activated = false;
            if(menuNumber == 1  && !activated){
                if(backButton.isDown){
                    menuNumber = 0;
                    back = new GreenfootImage("Menu/NH.bmp");
                    NH.reload(back);
                    childWorld.shadowQuality = shadowSlider.getStep();
                    childWorld.curveQuality = curveSlider.getStep();
                    childWorld.particleQuality = particleSlider.getStep();
                    childWorld.musicVolume = musicSlider.getStep();
                    childWorld.autoQualityAdjust = qualityBox.toggleOn;
                    activated = true;
                    removeObjects(getObjects(Pressable.class));
                }
            }
            if(menuNumber == 3  &&  !activated){
                if(rightButton.isDown && paneStart!=4){
                    paneStart++;
                }
                if(leftButton.isDown && paneStart!=0){
                    paneStart--;
                }
                
                back.setColor(Color.black);
                back.fillRect(0,225,400,40);
                back.setColor(new Color(60,60,60));
                
                for(int i=0;i<4;i++){
                    if(levelOffsets[i+paneStart] > farthestLevel){
                        panes[i].setImage("Menu/LevelBlank.bmp");      
                    }else{
                        panes[i].setImage("Menu/Level" + (i+paneStart) + ".bmp"); 
                        back.drawString(levelNames[i+paneStart],i*100+20,235);
                    }
                    if(panes[i].isDown && (levelOffsets[i+paneStart] <= farthestLevel)){
                        childWorld.character.removeAllBones();
                        childWorld.character = new Bill();
                        childWorld.addActionActor(childWorld.character,0,0);
                        childWorld.loadArea(levelOffsets[i+paneStart]);   
                        exitMenu();
                        return;
                    }
                }
                NH.reload(back);
                
                if(backButton.isDown){
                    menuNumber = 0;
                    back = new GreenfootImage("Menu/NH.bmp");
                    NH.reload(back);
                    activated = true;
                    removeObjects(getObjects(Pressable.class));
                }
                
                activated = true;   
            }
            if(menuNumber == 0  && !activated && Math.abs(my-204)<20){
                exitMenu();
                return;
            }
            if(menuNumber == 0  && !activated && Math.abs(my-293)<20){
                back.setColor(new Color(0,0,0,250));
                back.fillRect(0,80,400,240);  
                back.setColor(new Color(60,60,60));
                back.drawRect(0,80,400,240);
                
                rightButton = new Button("Menu/RightButton.bmp");
                addObject(rightButton,360,280);
                leftButton = new Button("Menu/LeftButton.bmp");
                addObject(leftButton,40,280);
                backButton = new Button("Menu/BackButton.bmp");
                addObject(backButton,200,300);
                
                for(int i=0;i<4;i++){
                    if(levelOffsets[i+paneStart] > farthestLevel){
                        panes[i] = new Button("Menu/LevelBlank.bmp");
                    }else{
                        panes[i] = new Button("Menu/Level" + (i+paneStart) + ".bmp");
                        back.drawString(levelNames[i+paneStart],i*100+20,235);
                    }
                    addObject(panes[i],i*100+60,180);
                }
                
                NH.reload(back);
                menuNumber = 3;
                activated = true;
                
                /*
                textEntry = new TextEntry("Chapter Name:");
                addObject(textEntry,200,200);
                menuNumber = 3;
                activated = true;
                */
            }
            if(menuNumber == 0  && !activated && Math.abs(my-246)<20){
                back.setColor(new Color(0,0,0,250));
                back.fillRect(80,80,240,240);  
                back.setColor(new Color(60,60,60));
                back.drawRect(80,80,240,240);
                
                back.drawLine(95,120,195,120);
                shadowSlider = new Slider(95,195,4,childWorld.shadowQuality);
                addObject(shadowSlider,95,128);
                back.drawLine(95,115,95,140);
                back.drawLine(195,115,195,140);
                back.drawString("Shadow Quality:",95,110);
                
                back.drawLine(95,170,195,170);
                curveSlider = new Slider(95,195,4,childWorld.curveQuality);
                addObject(curveSlider,95,178);
                back.drawLine(95,165,95,190);
                back.drawLine(195,165,195,190);
                back.drawString("Curve Detail:",95,160);
                
                back.drawLine(205,120,305,120);
                particleSlider = new Slider(205,305,4,childWorld.particleQuality);
                addObject(particleSlider,205,128);
                back.drawLine(205,115,205,140);
                back.drawLine(305,115,305,140);
                back.drawString("Particle Detail:",205,110);
                
                back.drawLine(95,270,195,270);
                musicSlider = new Slider(95,195,100,childWorld.musicVolume);
                addObject(musicSlider,95,278);
                back.drawLine(95,265,95,290);
                back.drawLine(195,265,195,290);
                back.drawString("Music Volume:",95,260);
                
                backButton = new Button("Menu/BackButton.bmp");
                addObject(backButton,301,309);
                
                qualityBox = new Checkbox(childWorld.autoQualityAdjust);
                addObject(qualityBox,210,160);
                back.drawString("Automatic Quality",220,165);
                back.drawString("Adjustment",220,185);
                //addObject(new Checkbox(false),210,180);
                //back.drawString("Save the Whales",220,185);
                
                NH.reload(back);
                menuNumber = 1;
                activated = true;
            }
        }
        
        if(my>188 && my<348 && mx<130 && mx>20 && menuNumber == 0){
            max1 = (int)((my+33)/43)*43-30;
            max2 = max1+40;
        }  
        //System.out.println(NH);
        for(int x=1;x<400;x++){
            double light = 0;
            for(int y=0;y<400;y++){
                
                light += NH.getMagAt(x,y)/80.0;
                double temp;
                if(y>max1 && y<max2 && x>20 && x<150){    
                    if(!pressed){
                        temp = 255-255*((1-light/256.0)*(1-NH.getMagAt(x,y)/3268.0));
                    }else{
                        temp = light;  
                    }
                }else{
                    temp = 255-255*((1-light/256.0)*(1-NH.getMagAt(x,y)/768.0));  
                }
                color[0] = (int)temp;
                color[1] = (int)temp;
                color[2] = (int)temp;
                image.setPixel(x,y,color);
                light *= Math.random()*.03 + rat + .9 + Math.pow(x/1500.0,2);
            }
        }
    }
    
    //public void enableCustomCursor(){    
    //    GreenfootImage image = new GreenfootImage("empty.png"); 
    //    Toolkit toolkit = Toolkit.getDefaultToolkit();
    //    Point cursorHotSpot = new Point(12,12);
    //    customCursor = toolkit.createCustomCursor(image.getAwtImage(), cursorHotSpot, "Cursor");
    //    panel.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    //    addObject(mouseCursor,0,0);
    //}
    
    //public void resetCursor(){
    //    GreenfootImage image = new GreenfootImage("empty.png"); 
    //    Toolkit toolkit = Toolkit.getDefaultToolkit();
   //     Point cursorHotSpot = new Point(12,12);
   //     customCursor = toolkit.createCustomCursor(image.getAwtImage(), cursorHotSpot, "Cursor");
    //    panel.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    //    removeObject(mouseCursor);
    //}
}
